{
   Piano.Spin

   uses CTRA to dimm-brighten the LED on P23 instead of blinking it on/off
   receives a frequency value and sends it to the Piano_Set object to
   set the speaker frequency   
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  RB_TX        = 1
  RB_RX        = 0
  RB_BAUD      = 115200
  D_TX         = 30
  D_RX         = 31
  D_BAUD       = 115200
  Blinker      = 23
  SetFlagMask  = %0000_0010
  ReadFlagMask = %0000_0001
  DimmerScale  = 16_777_216 ' 2 256   for DAC counter
                            ' to make dimming to be 0 to 255

OBJ
  RB     : "FullDuplexSerial"
  D      : "SerialMirror"
  Read   : "Program_08_Read"   'our object
  Set    : "Piano_Set"         'our object
  
PUB Main|x,t,c,n,f
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)
  D.Start(D_RX,D_TX,0,D_BAUD)
  Semaphore := LockNew                            'create Semaphore
  Set.Start(@Blink_Time,@Semaphore)               'start our object
  Read.Start(@ByteToSend,@Blink_Time,@Semaphore)  'start our object 
  ctrA[30..26] := %00110                          'Set ctra to DUTY mode
  ctrA[5..0]   := Blinker                         'Set ctra's APIN
  frqA := DimmerLevel* DimmerScale                'Set frqa register for off to start with
  dirA[Blinker]~~

  t := cnt                                        'init timer
  c := 1                                          'incrementer for the dim level
  repeat
     f~
     repeat n from 0 to 3                      'receive the 4 bytes of the Long
       repeat
           x := RB.RXcheck
           if (cnt-t)> Blink_Time              'if time out
              DimmerLevel += c                 'increment level
              if DimmerLevel == 255            'if top change incrementer to be -1
                c := -1
              elseif DimmerLevel == 0          'if lowest level change decrementer to 1 
                c := 1  
              frqA := DimmerLevel*DimmerScale  'set the frqA to effect the right Duty
              t := cnt                         'reset timer
       until x <> -1
       f.byte[n] := x                  'when byte received put it in right byte of the Long
     Set.PlayNote(f)                   'when all bytes received set the Frequency
     RB.TX(ByteToSend)                 'send buttons status
     if Not LockSet(Semaphore)         'only send if can acquire the semaphore   
        D.Str(string(13,"Main:"))                                      
        D.Dec(f)                                            
        D.Str(string("  , "))                      
        D.Dec(ByteToSend)
        Flags |= SetFlagMask | ReadFlagMask 'set flags
        LockClr(Semaphore)                  'clear the semaphore


Dat
  ByteToSend   Byte 0
  Semaphore    byte 0
  Flags        byte 0
  DimmerLevel  byte 0                'Duty level 0-255
  Blink_Time   Long 80_000_000/256   'take a second to brighten/dim all the way
  Blink1_Time  Long 160_000_000      '2 secs 2*80_000_000
  Blink2_Time  Long 240_000_000      '3 secs 3*80_000_000