{
   Piano_Set.Spin
   object used by Piano.Spin
   Sets the frequency for the speaker   
}
CON
  Speaker    = 4
  Blinker    = 21
  FlagMask   = %0000_0010

Var
  long Stacks[50],Frequency,tt

Obj
  D      : "SerialMirror"
  
PUB Start(Rates,Semaphore)
  cogNew(SetLEDs(Rates,Semaphore),@Stacks[0])

Pub PlayNote(Freq)
   Frequency := Freq
   tt := cnt        'start timeout timer
     
Pri SetLEDs(Rates,Semaphore)|t
  dirA[20..16]~~
  dirA[Blinker]~~
  t := cnt                           'initialize blinker timer
  ctrB[30..26] := %00100             'set ctrb to NCO
  ctrB[5..0]   := Speaker            'Set ctrb's APIN
  frqB~
  dirA[Speaker]~                     'speaker off for now
  tt := cnt                          'init speaker timer
  repeat
     if (cnt-tt) > 400_000_000       'if no frequency setting in 5 secs
       dirA[Speaker]~                'set pin as input to turn sound off
       tt := cnt                     'prevent too many timeouts
     if (cnt-t) => Long[Rates][2]    'blinker time out 
       !outA[Blinker]                'toggle the LED
       t := cnt                      'reset blinker timer
     if Frequency <> -1              'if value is received
        frqB := Frequency            'set frqB
        'phsB~                       'clear phsB causes clicking if uncommented
        dirA[Speaker] := (frqB <> 0) 'make the pin output allowing sound
        Frequency~~                  'reset to -1 to prevent replaying note
             
     if byte[Semaphore][1] & FlagMask      'only output to PST if flagged to do so
        if Not LockSet(byte[Semaphore])    'only send if can acquire the semaphore  
           D.Str(string(13,"Set:"))                                  
           D.Dec(frqB)
           byte[Semaphore][1] &= !FlagMask 'clear the flag                                  
           LockClr(byte[Semaphore])        'clear the semaphore           