//Program_10_B.BAS
//work with Program_10_Main.Spin
Port = 8  //change this as per your system
Main:
  gosub Initialization
  GoSub SetAllLevels
  while true
    call SendCommand(Command,Parameter,true)
    if timer()-P22_Timer > sValue[1]  //if P22 blinker time out
       P22_State = !P22_State \if !sValue[1] then P22_State=0
       CircleWH 455,205,20,20,FactorColor(ConsToClr(yellow),-20),LEDState[P22_State*2]
       P22_Timer = timer() //reset timer
    endif
    if timer()-P21_Timer > 500.0/Limit(sValue[2],1,255)  //if P22 blinker time out
       P21_State = !P21_State \if !sValue[2] then P21_State=0
       CircleWH 695,205,20,20,FactorColor(ConsToClr(yellow),-20),LEDState[P21_State*2]
       P21_Timer = timer() //reset timer
    endif  
  wend
end
//--------------------------------------------
Initialization:
  fnt = "Times New Roman"
  data LEDState;white,red,yellow
  setcommport Port,br115200   //set serial comms
  xyText 390,390,"Last Command , Parameter",fnt,11,fs_Bold
  xystring 10,10,"Click on the checkbox to light up the corresponding LED on the propeller"
  xystring 10,70,"Press the buttons on the Propeller and see the "+\
                 "corresponding LED light up"
  xyText 640,410,"If Lit => error",fnt,10,fs_Bold
  for i=0 to 4
     AddCheckBox "DS"+i,60+20*i,40," "   //add checkboxes as bits to form the
  next                                    //number to send
  data sLabel;"Dimmer Level (P23)","P22 Blink Duration","P21 Blink Frequency"
  data sCommand; 200,201,2
  data sValue; 0,0,0,127,127,10
  for i=0 to 2
    xyString 240*i+30,175,sLabel[i]
    AddSlider "P"+(23-i),10+240*i,200,200,0,255  
    SetSliderPos "P"+(23-i),sValue[i+3]
    call MakeValue(i,sValue[i+3]) 
    xyText 80+240*i,245,MakeValue__Result,fnt,20,fs_Bold  
  next
  call DrawDimmer(sValue[3])
  CheckBoxes = 0
  Command = 0 \ Parameter = 0   
  P22_Timer = timer() \ P22_State = 0  
  P21_Timer = timer() \ P21_State = 0  
  LastSlider()  'clear any slider events
  AddButton "&Reset The Propeller",500,500
  AddButton "&Execute Command",210,400
  data OtherCommands;"Example with 2 bytes return","Example with 5 bytes return"
  data OtherCommandsV;192,66
  data OtherCommandsP;2,5
  AddListBox "Commands",10,402,200,mToString(OtherCommands)
  SetListBox "Commands",1  
  onCheckBox cbHandler \ onSlider sHandler \onButton bHandler 
Return
//--------------------------------------------
SetAllLevels:
  serialout 1,_CheckBoxes    //force checkboxes to be reflected
  for i=0 to 2               //force blinkers and dimmers to be set 
     serialout sCommand[i],getsliderpos("P"+(23-i))
  next
Return
//--------------------------------------------
sub SendCommand(Command,Parameter,SetLeds)
    if Command
        xyText 450,420, Format(Command,"##0"+spaces(10))+\
              ",  "+Format(Parameter,"  ##0        "),_fnt,10,fs_Bold
    endif       
    ClearSerBuffer \ serialout Command,Parameter 
    _Command = 0 \ _Parameter = 0  //clear last command
    serbytesin 5,s,x
    circlewh 600,400,30,30,red,LEDState[(x<5)]  //set the error LED
    if x < 5 || !SetLeds then return s
    for i=0 to 2 
      circlewh 60+i*40,100,30,30,red,LEDState[Getstrbyte(s,i+1)&1]  //set the LED
    next
Return s
//--------------------------------------------
sub bHandler()
  lb = LastButton()
  msg="Are you sure you want to reset the Propeller"+crlf()+\
               "If the program is in RAM you will lose it!"
  if left(lb,2) == "&R"
     if ErrMsg(msg,"RobotBASIC",MB_YESNO|MB_ERROR)==MB_YES
          serialout 255,0            //reset
          delay 2000
          GoSub SetAllLevels
     endif     
  elseif left(lb,2) == "&E"
     n = GetListBox("Commands")-1 \ x = (OtherCommandsP[n] <3)
     call SendCommand(OtherCommandsV[n],0,x)   
     s = SendCommand__Result
     n = 1 \ if x then n=4
     ss = "Received bytes:"
     if Length(s)
       for i=n to 5
          ss += ""+getstrbyte(s,i)+","
       Next
     else
       ss += "Error "  
     endif  
     xyText 20,440,left(ss,length(ss)-1)+spaces(50),_fnt,,fs_Bold     
  endif
  onbutton bHandler
return
//--------------------------------------------
sub cbHandler()
  lcb = LastCheckBox()
  _CheckBoxes = MakeBit(_CheckBoxes,4-ToNumber(right(lcb,1)),GetCheckBox(lcb))
  xystring 200,40,"=",_CheckBoxes,spaces(20)
  _Command = 1 \ _Parameter = _CheckBoxes
  onCheckBox cbHandler
Return
//--------------------------------------------
sub sHandler()
  ls = LastSlider()
  _Parameter = GetSliderPos(ls)
  n = 23-tonumber(substring(ls,2))
  _Command = sCommand[n]
  if n == 0 then Call DrawDimmer(_Parameter)
  call MakeValue(n,_Parameter)
  xyText 80+240*n,245,MakeValue__Result,_fnt,20,fs_Bold
  onSlider sHandler
return
//--------------------------------------------
sub MakeValue(which,Level)
   if which == 0  'dimmer
      n = Level/256.0*3.3 
      Level = Format(n,"0.000 V  ")
   elseif which == 1  'P22 blink duration 
      n = Level*2000/256
      Level = Format(n,"####0 ms  ")
   else
      n = Level
      Level = Format(n,"##0  Hz  ")
   endif
   sValue[which] = n      
return Level
//--------------------------------------------
sub DrawDimmer(Level)
     CircleWH 212,202,26,26,white,white
     if !Level then return
     x = 1+(20*Level/256)/2
     Circle 225-x,215-x,225+x,215+x,red, RGB(Limit(Level,70,255),0,0)
return
