{
   Program_10_Main_simple.Spin
   Implement the new protocol
   in a simple way
   
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  RB_TX          = 1
  RB_RX          = 0
  RB_BAUD        = 115200
  D_TX           = 30
  D_RX           = 31
  D_BAUD         = 115200
  DimmerPin      = 23
  TimeOut1       = 240_000_000 '3 secs time out for receiving second byte
  TimeOut2       = 320_000_000 '4 secs time out for being allowed to send data
  OthersFlagMask = %0000_0001  'flag mask for flagging the Others Cog
  DimmerScale    = 16_777_216  ' 2 256   for DAC counter
                               ' to make dimming to be 0 to 255

OBJ
  RB     : "FullDuplexSerial"
  D      : "SerialMirror"
  Others : "Program_10_Others_Simple"  
  Reader : "Program_10_Reader_Simple"   
  
PUB Main|x,t
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)
  D.Start(D_RX,D_TX,0,D_BAUD)
  Sems_Flags[0] := LockNew           'create Semaphore
  Sems_Flags[2] := LockNew           'create Semaphore
  Others.Start(@Command,@Settings,@Sems_Flags)
  Reader.Start(@BytesToSend,@Settings,@Sems_Flags)
  ctrA[30..26] := %00110            'Set ctra to DUTY mode
  ctrA[5..0]   := DimmerPin         'Set ctra's APIN
  frqA := 127 *DimmerScale          'Set frqa register to mid level to start with
  dirA[DimmerPin]~~
  repeat
     Sems_Flags[1]~                 'reset flags
     LockClr(Sems_Flags[0])         'release semaphore
     repeat                         'wait forever to
         x := RB.RXcheck            'receive command byte  
     until x <> -1                  'can do things in this loop if needed
     Command[0] := x
     t := cnt                       'init timer
     repeat                         'wait with timeout to
         x := RB.RXcheck            'receive parameter
         if cnt-t > TIMEOUT1
             quit  
     until x <> -1                  'can do other things here if needed
     if x == -1                     'if no byte received loop back to the top
        Next                        'gracefully recover from receive error
     Command[1] := x
     if Not LockSet(Sems_Flags[2])
       D.Str(string(13,"Main Received:"))
       D.Dec(Command[0])
       D.Str(string(","))
       D.Dec(Command[1])
       LockClr(Sems_Flags[2])
     ExecuteTheCommand              'Execute the Command
     if Not Sems_Flags[1]           'if flags clear then send bytes
       repeat x from 0 to 4         'transmit the 5 bytes of data     
         RB.TX(BytesToSend[x])
       if Not LockSet(Sems_Flags[2])
         D.Str(string(13,"Main Sending:"))
         repeat x from 0 to 4         'transmit the 5 bytes of data     
           D.Dec(BytesToSend[x])
           D.Str(string(","))
         LockClr(Sems_Flags[2])

Pri ExecuteTheCommand|t
   case Command[0]
       255: 'reset the propeller
            Reboot
       200: 'set the Dimmer level on P23
            frqA := Command[1] *DimmerScale 
       201: 'set blinker rate for Reader cog(P22)
            '256 levels between 0 to 2 secs (0=off)               
            Settings[0] := Command[1]*(2_000/256)*(ClkFreq/1_000)
       1,2,66,192: 'commands in the Others cog
            Sems_Flags[1] |= OthersFlagMask    'set flag
            t:=cnt
            repeat until cnt-t > TIMEOUT2
               'wait for flag to clear with time out
               if Not(Sems_Flags[1] & OthersFlagMask)
                 quit 
                 
       
Dat
  Command      Byte 0,0               'command and parameter from RB
  BytesToSend  Byte 0,0,0,0,0         '5 bytes to send to RB
  Sems_Flags   byte 0,0,0             'semaphore1,flags,semaphore2 
  Settings     Long 80_000_000        'various settings buffer
                                      '[0] is Reader blinker rate
               
