{
   Ping_02.Spin
   Waits for RB to signal that it needs the data
   it then reads the time for the Ping and then
   Sends the data to RB using MSByte first

   It also sends the data to the PST for debug purposes.
}   
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
 RB_TX     = 1
 RB_RX     = 0
 RB_BAUD   = 115200
 D_TX      = 30
 D_RX      = 31
 D_BAUD    = 115200
 RCPin1    = 3
 RCPin2    = 2 
 PngPin    = 4
 
OBJ
  RB    : "FullDuplexSerial"
  D     : "SerialMirror"
 
PUB Main|x
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)
  D.Start(D_RX,D_TX,0,D_BAUD)
  waitcnt(ClkFreq/10+cnt)
  repeat
     RB.RX                   'wait for signal from RB
     x := Ping(PngPin)       'read the Ping
     D.Dec(x)                'send to the PST
     D.Tx(13)
     RB.Tx((x>>8) & $FF)     'send MSByte to RB
     RB.TX(x & $FF)          'send LSByte to RB

Pri Ping(Pin) : MS| x,time[2]
  outA[Pin]~               'set Pin low
  dirA[Pin]~~              'make Pin Output
  outA[Pin]~~              'Set Pin high
  outA[Pin]~               'Set Pin low ( results in a > 2 s pulse)
  dirA[Pin]~               'make Pin Input
  x:=cnt                   'start timing for timeout 
  repeat until inA[Pin]    'wait for Pin to go high
    if cnt-x > clkfreq/100 'with a 10ms time out
      return 0             'if timed out then return 0
  time[0] := cnt           'store Current Counter Value
  waitpeq(0, |< Pin, 0)    'wait For Pin To Go LOW 
  time[1] := cnt           'store New Counter Value
  MS :=||(time[0] - time[1])/(clkfreq / 1_000_000) ' Return Time in s