//Pots_02.Bas
//works with Pots_02.Spin
Port = 8  //change this as per your system
Main:
  gosub Initialization
  while true
     call ReadRC(P1,P2)
     setsliderpos "Pot0",P1
     setsliderpos "Pot1",P2
     for i=0 to 1
        xystring 150+300*i,90,Format(GetSliderPos("Pot"+i),"####0")
     next
  wend
end
//-----------------------------------------
Initialization:
  setcommport Port,br115200
  dim P[2,3] \  mconstant P,0
  fnt = "Times New Roman"
  xytext 30,2,"Change the Pots' positions and observe the Sliders",fnt,20,fs_bold
  AddButton "&Calibrate",290,120
  AddButton "&Finished",290,420
  HideButton "&Finished"
  AddSlider "Pot0",50,50,250,0,6000
  AddSlider "Pot1",350,50,250,0,6000
  enableslider "Pot0",false \ enableslider "Pot1",false
  call WriteLabels()
  onbutton bHandler
Return
//-----------------------------------------
sub bHandler()
  lb = lastbutton()
  Hidebutton lb
  HideButton "&Finished",false
  savescr
  w = 650 \ h = 200
  rectanglewh 90,290,w,h,black,black
  rectanglewh 85,285,w,h,,gray
  xytext 100,300,"Move the Pots from max to min waiting a little while",_fnt,20,fs_Bold,,gray
  xytext 100,330,"at each end then repeat the process a few times",_fnt,20,fs_Bold,,gray  
  xytext 100,360,"When done press 'Finished'",_fnt,20,fs_Bold,,gray  
  call Calibrate()
  restorescr
  call WriteLabels()
  Hidebutton lb,false
  HideButton "&Finished"
  onbutton bHandler
return
//-----------------------------------------
sub Calibrate()
  mconstant P,0
  while true
     if LastButton() != "" then return
     call ReadRC(P1,P2)
     if !ReadRC__Result then continue
     P[0,1] = P1 \ P[1,1] = P2
     for i=0 to 1
        P[i,2] = MaxV(P[i,2],P[i,1]) 
        P[i,0] = MinV(P[i,0],P[i,1])         
        SetSliderMax "Pot"+i,P[i,2]
        SetSliderMin "Pot"+i,P[i,0]
        SetSliderPos "Pot"+i,P[i,1]
     next
     Call WriteLabels()
  wend
return
//-----------------------------------------
sub WriteLabels()
  for i=0 to 1
     xystring 40+300*i,90,GetSliderMin("Pot"+i) 
     xystring 280+300*i,90,GetSliderMax("Pot"+i) 
     xystring 150+300*i,90,Format(GetSliderPos("Pot"+i),"####0")
  next   
return
//-----------------------------------------
sub ReadRC(&P1,&P2)
   P1 = -1 \ P2 = -1
   serialout 1
   serbytesin 4,s,n
   if n < 4 then return false
   P1 = (getstrbyte(s,1)<<8)+getstrbyte(s,2)
   P2 = (getstrbyte(s,3)<<8)+getstrbyte(s,4)
Return true   
//-----------------------------------------
