//Program_12_Advanced_.BAS
//work with Program_12_Main.Spin
Port = 8  //change this as per your system
Main:
  gosub Initialization
  GoSub SetAllLevels
  while true
    call CheckMouseKeyboard()
    if Command == -1 then call DoPing(PX,PY)
    if Command == -1 then call DoPots()
    call SendCommand(Command,Parameter)
    if timer()-P22_Timer > sValue[1]  //if P22 blinker time out
       P22_State = !P22_State \if !sValue[1] then P22_State=0
       CircleWH 455,205,20,20,FactorColor(ConsToClr(yellow),-20),LEDState[P22_State*2]
       P22_Timer = timer() //reset timer
    endif
    if timer()-P21_Timer > 500.0/Limit(sValue[2],1,255)  //if P22 blinker time out
       P21_State = !P21_State \if !sValue[2] then P21_State=0
       CircleWH 695,205,20,20,FactorColor(ConsToClr(yellow),-20),LEDState[P21_State*2]
       P21_Timer = timer() //reset timer
    endif  
  wend
end
//--------------------------------------------
Initialization:
  fnt = "Times New Roman"
  data LEDState;white,red,yellow
  setcommport Port,br115200   //set serial comms
  xyText 390,100,"Last Command , Parameter",fnt,11,fs_Bold
  xystring 10,10,"Click on the checkbox to light up the corresponding LED on the propeller"
  xystring 10,70,"Press the buttons on the Propeller and see the "+\
                 "corresponding LED light up"
  xyText 640,110,"If Lit => error",fnt,10,fs_Bold
  for i=0 to 2
     AddCheckBox "DS"+i,60+20*i,40," "   //add checkboxes as bits to form the
  next                                    //number to send
  data sLabel;"Dimmer Level (P23)","P22 Blink Duration","P21 Blink Frequency"
  data sCommand; 200,201,2
  data sValue; 0,0,0,127,127,10
  for i=0 to 2
    xyString 240*i+30,175,sLabel[i]
    AddSlider "P"+(23-i),10+240*i,200,200,0,255  
    SetSliderPos "P"+(23-i),sValue[i+3]
    call MakeValue(i,sValue[i+3]) 
    xyText 80+240*i,245,MakeValue__Result,fnt,20,fs_Bold  
  next
  call DrawDimmer(sValue[3])
  CheckBoxes = 0
  Command = 0 \ Parameter = 0   
  P22_Timer = timer() \ P22_State = 0  
  P21_Timer = timer() \ P21_State = 0  
  LastSlider()  'clear any slider events
  AddButton "&Reset The Propeller",650,30
  GoSub InitPing \ GoSub  InitPots \ GoSub InitMotors
  onCheckBox cbHandler \ onSlider sHandler \ onButton bHandler
Return
//--------------------------------------------
SetAllLevels:
  serialout 1,_CheckBoxes    //force checkboxes to be reflected
  for i=0 to 2               //force blinkers and dimmers to be set 
     serialout sCommand[i],getsliderpos("P"+(23-i))
  next
Return
//--------------------------------------------
sub SendCommand(Command,Parameter,&s)
    if Command < 0 then s="" \ return false
    xyText 450,120, Format(Command,"##0"+spaces(10))+\
              ",  "+Format(Parameter,"  ##0        "),_fnt,10,fs_Bold
    ClearSerBuffer \ serialout Command,Parameter
    _Command = -1 \ _Parameter = -1
    serbytesin 5,s,x
    circlewh 600,100,30,30,red,LEDState[(x<5)]  //set the error LED
    if x < 5 then s = "" \ return false
    if Command == 66 then return true
    for i=0 to 2 
      circlewh 60+i*40,100,30,30,red,LEDState[Getstrbyte(s,3-i)&1]  //set the LEDs
    next
Return true
//--------------------------------------------
sub CheckMouseKeyboard()
   readmouse x,y,mb
   if mb=1 
      call WhichIsIt(x,y,_MX,_MY,_MS,n)
      _Command = n \ _Parameter = 1  //changed this to 1
   elseif KeyDown()
     _Parameter = 1  //change this to 1
     if keydown(kc_UArrow) then _Command = 6
     if keydown(kc_DArrow) then _Command = 7  
     if keydown(kc_RArrow) then _Command = 12
     if keydown(kc_LArrow) then _Command = 13
     if keydown(kc_Space)  then _Command = 0   
   endif   
return
//--------------------------------------------
sub bHandler()
  lb = LastButton()
  msg="Are you sure you want to reset the Propeller"+crlf()+\
               "If the program is in RAM you will lose it!"
  if left(lb,2) == "&R"
     if ErrMsg(msg,"RobotBASIC",MB_YESNO|MB_ERROR)==MB_YES
          serialout 255,0            //reset
          delay 2000
          GoSub SetAllLevels
     endif     
  elseif left(lb,2) == "&C"
     Hidebutton lb
     HideButton "&Finished",false
     mconstant P,0
     CopyScr ,350,400
     rectanglewh 380,405,300,100,black,black
     rectanglewh 378,402,300,100,black,gray
     xytext 384,410,"Move the Pots from max to min waiting a little while",\
             _fnt,10,fs_Bold,,gray
     xytext 384,430,"at each end then repeat the process a few times",_fnt,\
             10,fs_Bold,,gray  
    xytext 384,450,"When done press 'Finished'",_fnt,10,fs_Bold,,gray  
     _Calibrate = true
  elseif left(lb,2) == "&F"
     HideButton lb
     HideButton "&Calibrate",false
     _Calibrate = false
     copytoscr ,350,400
     call WriteLabels()
  endif
  onbutton bHandler
return
//--------------------------------------------
sub cbHandler()
  lcb = LastCheckBox()
  _CheckBoxes = MakeBit(_CheckBoxes,2-ToNumber(right(lcb,1)),GetCheckBox(lcb))
  xystring 200,40,"=",_CheckBoxes,spaces(20)
  _Command = 1 \ _Parameter = _CheckBoxes
  onCheckBox cbHandler
Return
//--------------------------------------------
sub sHandler()
  ls = LastSlider()
  if left(ls,3) !="Pot"
    _Parameter = GetSliderPos(ls)
    n = 23-tonumber(substring(ls,2))
    _Command = sCommand[n]
    if n == 0 then Call DrawDimmer(_Parameter)
    call MakeValue(n,_Parameter)
    xyText 80+240*n,245,MakeValue__Result,_fnt,20,fs_Bold
  endif
  onSlider sHandler
return
//--------------------------------------------
sub MakeValue(which,Level)
   if which == 0  'dimmer
      n = Level/256.0*3.3 
      Level = Format(n,"0.000 V  ")
   elseif which == 1  'P22 blink duration 
      n = Level*2000/256
      Level = Format(n,"####0 ms  ")
   else
      n = Level
      Level = Format(n,"##0  Hz  ")
   endif
   sValue[which] = n      
return Level
//--------------------------------------------
sub DrawDimmer(Level)
     CircleWH 212,202,26,26,white,white
     if !Level then return
     x = 1+(20*Level/256)/2
     Circle 225-x,215-x,225+x,215+x,red, RGB(Limit(Level,70,255),0,0)
return
//-----------------------------------------
//-----------------------------------------
InitPing:
  data units;"Millimeters","Meters","Inches","Feet","Yards"
  data unitn; " mm"," m"," in"," ft"," Yrds"
  data factors;1.,.001,Convert(.001,cc_MTOIN)
  data factors;Convert(.001,cc_MTOIN)/12
  data factors;Convert(Convert(.001,cc_MTOIN)/12,cc_FTTOYRD)
  AddRBGroup "Units",10,300,200,100,2,mToString(units)
  SetRBGroup "Units",1
  PX = 10 \ PY = 480
  call DrawPing(PX,PY)
  savescr 0,400,350
Return
//-----------------------------------------
sub DoPing(Px,Py)
  call SendCommand(192,0,s)
  if !SendCommand__Result then  return
  t = (getstrbyte(s,4)<<8)+getstrbyte(s,5) //reconstitute the value  
  call mmDistance(,t,D)                //convert to mm
  n=getrbgroup("Units")-1              //get desired units
  x=Format(D*factors[n],"0.0####")     //convert to units and format
  call DrawSignal(Px,Py,t,x+unitn[n])  //draw beam and display value in units
Return
//-----------------------------------------
sub mmDistance(Tc,t,&D)
   if !vType(Tc) then Tc = 22.2      //if no temp specified assume 22.2 C
   D = 0.5*t*(331.5 + 0.6* Tc)/1000  //convert time to mm
Return D
//-----------------------------------------
sub DrawPing(x,y)   //draw picture of Ping device
  s = 30
  for i=-1 to 1 step 2
    line x,y+s*i,x+20,y+s*i,40,gray
    circlewh x+30,y-20+s*i,40,40,white,white
  next
  rectanglewh x-20,y-2*s,25,s*4,white,white
  rectanglewh x-2,y-s*2,10,s*4,green,green
Return
//-----------------------------------------
sub DrawSignal(x,y,d,str)
  d *= 200.0/19000      //scale value to screen coordinates
  restorescr 0,400
  xx1 = x+20+CartX(d,dtor(20))
  yy1 = y+CartY(d,dtor(20))
  Line x+20,y,xx1,yy1
  xx2 = x+20+CartX(d,dtor(-20))
  yy2 = y+CartY(d,dtor(-20))
  Line x+20,y,xx2,yy2
  Line xx1,yy1,xx2,yy2
  if d > 3 then floodfill x+20+d/2,y,black
  xytext x,y+80,str,,20,fs_bold
  //flip
return
//-----------------------------------------
//-----------------------------------------
InitPots:
  dim P[2,3] \  mconstant P,0
  xytext 380,290,"Change the Pots' positions and observe the Sliders",fnt,9,fs_bold
  AddButton "&Calibrate",460,370
  AddButton "&Finished",460,370
  HideButton "&Finished"
  AddSlider "Pot0",220,310,250,0,6000
  AddSlider "Pot1",520,310,250,0,6000
  enableslider "Pot0",false \ enableslider "Pot1",false
  call WriteLabels()
  Calibrate = false
Return
//----------------------------------------
sub DoPots()
  call SendCommand(66,0,s)
  if !SendCommand__Result then return
  P2 = (getstrbyte(s,1)<<8)+getstrbyte(s,2)
  P1 = (getstrbyte(s,3)<<8)+getstrbyte(s,4)
  setsliderpos "Pot0",P1
  setsliderpos "Pot1",P2
  for i=0 to 1
     xystring 320+300*i,350,Format(GetSliderPos("Pot"+i),"####0")
  next
  If _Calibrate then Call Calibration(P1,P2)
Return
//----------------------------------------
sub WriteLabels()
  for i=0 to 1
     xystring 210+300*i,350,GetSliderMin("Pot"+i) 
     xystring 450+300*i,350,GetSliderMax("Pot"+i) 
     xystring 320+300*i,350,Format(GetSliderPos("Pot"+i),"####0")
  next   
return
//----------------------------------------
sub Calibration(P1,P2)
     P[0,1] = P1 \ P[1,1] = P2
     for i=0 to 1
        P[i,2] = MaxV(P[i,2],P[i,1]) 
        P[i,0] = MinV(P[i,0],P[i,1])         
        SetSliderMax "Pot"+i,P[i,2]
        SetSliderMin "Pot"+i,P[i,0]
        SetSliderPos "Pot"+i,P[i,1]
     next
     Call WriteLabels()
return
//-----------------------------------------
//-----------------------------------------
InitMotors:
  arrow = "UlulwwssldlU"
  MX = 750 \ MY = 500 \ MS = 10
  for i=0 to 3
     drawshape RotShape(arrow,i),MX,MY,MS
     floodfill ,,black
  next
  xyText 600,550,"Move Motors with Keyboard Arrows",fnt,8,fs_Bold
  xyText 600,565,"Or Click on the arrows above",fnt,8,fs_Bold
  xyText 580,580,"Space or click in middle white box to Stop",fnt,8,fs_Bold  
Return
//-----------------------------------------
sub WhichIsIt(x,y,Cx,Cy,Scale,&n)
  n = -1
  f2 = Scale*2 \ f4=Scale*4
  if within(x,Cx-f2,Cx+f2)       && within(y,Cy-f4,Cy-Scale)    then n=6
  if within(x,Cx-f2,Cx+f2)       && within(y,Cy+Scale,Cy+f4)    then n=7
  if within(x,Cx+Scale,Cx+f4)    && within(y,Cy-f2,Cy+f2)       then n=12
  if within(x,Cx-f4,Cx-Scale)    && within(y,Cy-f2,Cy+f2)       then n=13
  if within(x,Cx-Scale,Cx+Scale) && within(y,Cy-Scale,Cy+Scale) then n=0
return

