{
  Servomotor_04.Spin
  Drives 2 servomotors on P16..P17 (or just LED)
  But uses a Cog
  And interacts with Servomotor_04.BAS to drive both motors
  forward/backwards or to turn right/left
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
  RB_TX    = 1
  RB_RX    = 0
  RB_BAUD  = 115200

  Blinker = 23
  MidVal  = 1500
  MinVal  = 1000
  MaxVal  = 2000
  
Var
   long Stack[10],Pulse[2]

Obj
  RB: "FullDuplexSerial"

PUB Main|t,x
  Pulse[0] := Pulse[1] := MidVal
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)      'start the serial driver
  cognew(Servos(16,17,@Pulse),@Stack)  'start the Servos driver
  dirA[Blinker]~~
  t := cnt
  repeat
     if cnt-t > clkfreq
       !outA[Blinker]
       t := cnt
     x := RB.RxCheck
     if x == -1
        Next
     case x
        0: StopMotors(0)                  'stop     
        1: StopMotors(1)     
           Pulse[0] := MinVal             'forward
           Pulse[1] := MaxVal  
        2: StopMotors(1)     
           Pulse[0] := MaxVal             'backward
           Pulse[1] := MinVal  
        3: StopMotors(1)     
           Pulse[0] := Pulse[1] := MinVal 'right             
        4: StopMotors(1)     
           Pulse[0] := Pulse[1] := MaxVal  'left  
     RB.Tx(x)     

Pri StopMotors(wait)
  Pulse[0] := Pulse[1] := MidVal       'stop motors
  if wait
    waitcnt(cnt+(clkfreq/1_000_000)*50)  'wait 50 microsecs
  
Pri Servos(ServoPin0,ServoPin1,Pulses)
  dirA[ServoPin0]~~                      'set pins as output
  dirA[ServoPin1]~~
  repeat
    outA[ServoPin0]~~
    waitcnt(cnt+Long[Pulses][0]*(clkFreq/1_000_000))
    outA[ServoPin0]~
    outA[ServoPin1]~~
    waitcnt(cnt+Long[Pulses][1]*(clkFreq/1_000_000))
    outA[ServoPin1]~
    waitcnt(cnt+(20_000-Long[Pulses][0]-Long[Pulses][1])*(clkfreq/1_000_000))