{
   Firmware_Reader_G.Spin
   reads the pushbuttons and sets the top 3 bytes
   Also QTI
   Also speaker
}
CON
  Blinker    = 22
  QTI_Top    = 10
  QTI_Bottom = 8
  Speaker    = 11

Var
  long CogN,Stacks[50]
  long t, SendBuffer,Settings,Sems_Flags ,tt,Frequency
  byte LocalBytes[3]

Obj
  D      : "SerialMirror"

Dat
  Notes   Long 0
          Long 1756,1860,1971,2088,2212,2344
          Long 2483,2631,2787,2953,3128,3314
          Long 3511,3720,3941,4176,4424,4687
          Long 4966,5261,5574,5906,6257,6629
          Long 7023,7440,7883,8352,8810,9374
          Long 9932,10523,11148,11811,12513,13257
          Long 14046,14881,15766,16704,17697,18749
          Long 19864,21045,22297,23622,25027,26515
          Long 28092,29763,31532,33407,35394,37498
          Long 39728,42090,44593,47245,50054,53030
          Long 56184,59523,63066,66814,70786,74995
          Long 79457,84181,89185,94489,100110,106059
          Long 112367,119051,126127,133627,141573,149991
          Long 158914,168363,178370,188979,200215,212123

  
PUB Start(SendBufferAddr,SettingsAddr,Sems_FlagsAddr)
  SendBuffer  := SendBufferAddr   'save all passed addresses as   
  Settings    := SettingsAddr      'local variables to be used     
  Sems_Flags  := Sems_FlagsAddr    'by all processes             
  CogN := Result :=cogNew(Reader,@Stacks[0])+1        'start the cog

Pub Stop
  If CogN
     CogStop(CogN~ -1)

Pub Play_Note(Note)
  Frequency := Notes[(0 #> Note <# 84)] 'set frqB
  tt := cnt                             'set the timer

Pri Reader
  Initialization
  repeat
     Process0
     ReadByte0
     ReadByte1
     ReadByte2
     PutBytesInSendBuffer

Pri Initialization
  'initialize variables I/O direction etc.
  outA[QTI_Top..QTI_Bottom]~~
  dirA[Blinker]~~
  t := cnt                  'initialize the timer
  ctrB[30..26] := %00100    'set ctrb to NCO
  ctrB[5..0]   := Speaker   'Set ctrb's APIN
  frqB~                     'clear freqB
  dirA[Speaker]~            'speaker off for now
  tt := cnt                 'init speaker timer

Pri Process0
  'can do anything here. That require polling or regular updating
  'For example we are blinking an LED on P22 using a stop watch
  'action with the variable t that hast to be initialized before
  'calling this process for the first time.
  if Long[Settings][0] == 0            'if duration is 0 then off
    outA[Blinker]~
  elseif (cnt-t) => Long[Settings][0]  'blinker time out
    !outA[Blinker]                     'toggle the LED
    t :=cnt                            'reset the timer
  if Frequency <> -1  
     frqB := Frequency            'set frqB
     'phsB~                       'clear phsB will cause clicking if uncommented
     dirA[Speaker] := (frqB <> 0) 'make the pin output allowing sound
     Frequency~~                  'set Frequency to -1 to prevent re-playing
  if (cnt-tt) > 400_000_000       'if no new frequency in 5 secs
    dirA[Speaker]~                'set pin as input to turn sound off
    tt := cnt

Pri ReadByte0
  'could do all sorts of actions here that are needed
  'to read the byte from any source eg. Bumpers
  'for now just read the pushbutton on P5 invert it
  'and mask it to make sure it is and active high not low
  'and in the LSbit 
  LocalBytes[0]:= !inA[5] & %01

Pri ReadByte1
  'could do all sorts of actions here that are needed
  'to read the byte from any source eg. Bumpers
  'for now just read the pushbutton on P6 invert it
  'and mask it to make sure it is and active high not low
  'and in the LSbit 
  LocalBytes[1]:= !inA[7..6] & %11
  
Pri ReadByte2
  'could do all sorts of actions here that are needed
  'to read the byte from any source eg. Bumpers
  'for now just read the pushbutton on P7 invert it
  'and mask it to make sure it is and active high not low
  'and in the LSbit 
  dirA[QTI_Top..QTI_Bottom]~~                  'turn pins to output
  waitcnt(clkfreq/100_000*23+cnt)              'wait 230 us
  dirA[QTI_Top..QTI_Bottom]~                   'make the pins input
  waitcnt(clkfreq/100_000*23+cnt)              'wait 230 us
  LocalBytes[2]:=inA[QTI_Top..QTI_Bottom]      'read the states and store in byte
  

Pri PutBytesInSendBuffer|i
  if Not LockSet(byte[Sems_Flags][0])   'only set the bytes to send if got semaphore
    repeat i from 0 to 2
      byte[SendBuffer][i] := LocalBytes[i]
    LockClr(byte[Sems_Flags][0])        'clear the semaphore
    'OutputToPST                         'send some info to the PST        

Pri OutputToPST|i
  if Not LockSet(byte[Sems_Flags][2]) 'write debug messages to the PST
    D.Str(string(13,"Reader:"))       '   if semaphore aquired
    repeat i from 0 to 2
       D.Dec(byte[SendBuffer][i])   
       D.Str(string(","))
    LockClr(byte[Sems_Flags][2])
         