//Ping_TCP.Bas
//works with Protocol_Main.Spin
//but over the LAN or internet
Port = 0  //change this as per your system
#include "..\Utilities&IncludeFiles\Instruments.Bas"
TCPS_IP = "192.168.0.198" \ TCPS_Port = 50000
tcpc_Connect(TCPS_IP,TCPS_Port)
//-----------------------------------------
Main:
  gosub Initialization
  while true
     call ReadPing(t)                     //get the time value from the propeller
     if ! ReadPing__Result then continue  //if failed loop back
     call mmDistance(,t,D)                //convert to mm
     n=getrbgroup("Units")-1              //get desired units
     x=Format(D*factors[n],"0.0####")     //convert to units and format
     call DrawSignal(Px,Py,t,x+unitn[n])  //draw beam and display value in units
  wend
end
//-----------------------------------------
Initialization:
  setcommport Port,br115200
  data units;"Millimeters","Meters","Inches","Feet","Yards"
  data unitn; " mm"," m"," in"," ft"," Yrds"
  data factors;1.,.001,Convert(.001,cc_MTOIN)
  data factors;Convert(.001,cc_MTOIN)/12
  data factors;Convert(Convert(.001,cc_MTOIN)/12,cc_FTTOYRD)
  AddRBGroup "Units",10,10,200,100,2,mToString(units)
  SetRBGroup "Units",1
  Px = 10 \ Py = 300
  call DrawPing(Px,Py)
  savescr
  Flip on
Return
//-----------------------------------------
sub ReadPing(&P)
   P = -1
   //serialout 192,0                //signal the Propeller
   //serbytesin 5,s,n              //receive the value bytes
   call TCP_SendCommand(192,0,s,n)
   if n < 5 then return false    //if error just return false
   P = (getstrbyte(s,4)<<8)+getstrbyte(s,5) //reconstitute the value
Return true   
//-----------------------------------------
 sub DrawPing(x,y)   //draw picture of Ping device
  s = 30
  for i=-1 to 1 step 2
    line x,y+s*i,x+20,y+s*i,40,gray
    circlewh x+30,y-20+s*i,40,40,white,white
  next
  rectanglewh x-20,y-2*s,25,s*4,white,white
  rectanglewh x-2,y-s*2,10,s*4,green,green
Return
//-----------------------------------------
sub DrawSignal(x,y,d,str)
  d *= 500.0/22000      //scale value to screen coordinates
  restorescr
  xx1 = x+20+CartX(d,dtor(20))
  yy1 = y+CartY(d,dtor(20))
  Line x+20,y,xx1,yy1
  xx2 = x+20+CartX(d,dtor(-20))
  yy2 = y+CartY(d,dtor(-20))
  Line x+20,y,xx2,yy2
  Line xx1,yy1,xx2,yy2
  if d > 3 then floodfill x+20+d/2,y,black
  xytext x,y+80,str,,20,fs_bold
  flip
return
//-----------------------------------------

