//H48C_Plane_RB.Bas
//works with Protocol_Main.Spin
Port = 16 //change this as per your system
#include "..\Utilities&IncludeFiles\Instruments.Bas"
Main:
  gosub Initialization
  while true
     call Read_H48C(v,x,y,z,gX,gY,gZ)
     xystring 10,10,v;x-v;y-v;z-v;spaces(20)
     xystring 50,30,Format(gX,fmta),Format(gY,fmta),Format(gZ,fmta)
     xystring 50,50,Format(rtod(atan2(gX,gZ))-90,fmtb)
     xystring -1,-1,Format(rtod(atan2(gY,gZ))-90,fmtb)
     xystring -1,-1,Format(rtod(atan2(gZ,gY)),fmtb)  
     //v = 0    //uncomment this to refresh the vRef all the time
     call PlotPlane(gX,gY,gZ,rCompass())
  wend
End
//=================================
Initialization:
  fmta = "#0.0000   " \ fmtb = "  #00     "
  rcommport Port,br115200
  rLocate 30,30
  v = 0
  data plane;9,.5,6,1.5,4,1.5
  data plane;0,8.5,-1,8.5,-1,1.5,-4,.5,-5,3.5,-6,3.5
  data plane;-6,-3.5,-5,-3.5,-4,-0.5,-1,-1.5,-1,-8.5,0,-8.5
  data plane;4,-1.5,6,-1.5,9,-0.5,9,.5
  
  data Eye;170,pi(),pi(.30),1550,400,350 //rho,theta,phi,d,Cx,Cy
  dim Plane[maxdim(plane)/2,5]
  mconstant Plane,0
  for i=0 to maxdim(plane)/2 -1
    Plane[i,0] = plane[i*2]
    Plane[i,1] = plane[i*2+1]
  next
  flip on
  AddCheckBox "Mode",630,130,"&Real Mode",1,0
return
//=================================
sub PlotPlane(gX,gY,gZ,H)
  thX = atan2(gX,gZ)-pi(.5) //x-tilt
  thY = atan2(gY,gZ)-Pi(.5) //y-tilt
  mcopy Plane,K  //refresh body coordinates array
  geRotateA K,-thY,1 //rotate around x-axis i.e. Roll
                     //negative to orientate for Right-Handed Standard
  geRotateA K,thX,2  //rotate around y-axis i.e. Pitch
  //geRotateA K,dtor(-H),3  //rotate around z-axis i.e. Heading
                            //negative to orientate for Right-Handed Standard
  ge3dto2da K,Eye    //calculated screen coordinates
  for i=1 to maxdim(K)-1  //plot the plane
    line K[i-1,3],K[i-1,4],K[i,3],K[i,4]
  next
  call DisplayCompass(!GetCheckBox("Mode"),H,600,200) 
  call DisplayAttitude(thX,-thY,200,200)
  flip
  clearscr
return
//=================================
sub SendCommand(C,P,&s)
  m = ""
  //serialout C,P
  //serbytesin 5,s,x
  s = rCommand(C,P) \ x = Length(s)
  if x < 5 then m= "Comms Error"
  xystring 500,20,m,spaces(30)  
return (x == 5)
//=================================

