//Other_Devices.Bas
//Works with Protocol_Main.Spin
Port = 16 //set this as per your system
Main:
  rcommport Port,br115200
  rLocate 400,100
  xystring 10,10,"Pot1    Pot2     gX          gY       gZ "
  j = 0
  while true
   rCommand(8+j,100)  //turn right motor forward
   for i=0 to 10
      call DisplayData()  //read and display Accel and Gps
      rCommand(73,i+74)   //play a note on the speaker
      delay 100
   next
   rCommand(8,0)       //stop
   rCommand(11-j,100)  //turn left motor backwards
   for i=0 to 10
      call DisplayData()  //read and display Accel and Gps
      rCommand(73,84-i)   //play a note on the speaker
      delay 100
   next      
   rCommand(11,0)    //stop
   j = !j
  wend 
End
//===================================================
sub DisplayData()
  rGps x,y
  call Read_H48C(0,,,,xg,yg,zg)  //get and calculate the g-forces
  xystring 1,30,Format(x,"####0");Format(y,"####0")
  fmt = "#0.0000"
  xystring -1,-1,"  ",Format(xg,fmt);Format(yg,fmt);Format(zg,fmt)
Return
//===================================================
sub Read_H48C(&vRef,&xRef,&yRef,&zRef,&xG,&yG,&zG)
  xRef = 0 \ yRef = 0 \ zRef = 0 
  xG =0 \ yG = 0 \ zG = 0
  if vRef == 0
     s = rCommand(70,1) //read vRef
     if Length(s)!= 5 then return false
     vRef = (getstrbyte(s,4)<<8)+getstrbyte(s,5)
  endif
  s = rCommand(70,0) //read the axes
  if Length(s) != 5 then return false
  xRef = (getstrbyte(s,1) << 4) + (getstrbyte(s,2) >>4)
  yRef = ((getstrbyte(s,2)&0x0F) << 8) + getstrbyte(s,3)
  zRef = (getstrbyte(s,4) << 4) + (getstrbyte(s,5) >> 4)
  xG = (xRef-vRef)*.0022  //convert to g-forces
  yG = (yRef-vRef)*.0022
  zG = (zRef-vRef)*.0022
return true

