//Simulator_3.Bas
//works with Protocol_Main.Spin
Port = 0 //change this per your system, if 0 then the simulator is active
Main:
   GoSub Initialization
   while true
     if timer()-t > TimeLimit 
        GoSub Initialization
        t = timer()
        waitnokey 
     endif   
     GoSub RoamAround
   wend
end
//------------------------------------------------   
RoamAround:
  //notice how Shift_Factor and R_Factor are used
  while !((rBumper()<<Shift_Factor)&0%0100) \
       && rRange()*R_Factor > RangeLimit  //while path is not blocked
     if KeyDown(kc_Space) then t=0 \return  
     rForward 1
  wend
  T = (random(1000)>500)*2 -1   //determine a random turn direction
  while rRange()*R_Factor <= RangeLimit  //keep turning until path is clear
     if KeyDown(kc_Space) then t=0 \return  
     rTurn T
  wend
  rTurn T*(20+random(30))  //turn a little more in the same direction
Return
//------------------------------------------------
Initialization:
  if !vType(FirstTime)
    t = 0 \ TimeLimit = 60000  //60 secs
    if Port                            //if not simulation
      rCommPort Port,br115200
      call mmDistance(,1,R_Factor)    //calculate Ping)) factor
      Shift_Factor = 2                //shift rBumper byte 2
      RangeLimit = 300                //ranger limit
    Else                               //if simulation
      R_Factor=1
      Shift_Factor = 0
      RangeLimit = 30
    endif
    LineWidth 10
    FirstTime = false
  endif   
  clearscr
  //draw some obstacle for the simulation
  for i=0 to 3
    x = 50+ Random(700) \ y = 50+random(500)
    W = limit(random(400)+x,80,790)-x
    H = limit(random(300)+y,80,590)-y
    rectanglewh 50+random(750),50+random(550),W,H,blue
  next    
  rlocate 30,30,135-random(45)
return
//------------------------------------------------
sub mmDistance(Tc,t,&D)
   if !vType(Tc) then Tc = 21        //if no temp specified assume 21c
   D = 0.5*t*(331.5 + 0.6* Tc)/1000  //convert time to mm
Return D

