//H48C_Plane_Extended_TCP.Bas
//works with Extended_Protocol_Main.Spin
//but over the LAN or internet
TCPS_IP = "192.168.0.198" \ TCPS_Port = 50000
tcpc_Connect(TCPS_IP,TCPS_Port)
Port = 0 //change this as per your system
#include "..\Utilities&IncludeFiles\Instruments.Bas"
//--------------------------------------------
Main:
  gosub Initialization
  while true
     call Read_H48C_E(x,y,z,gX,gY,gZ)
     xystring 10,10,x;y;z;spaces(20)
     xystring 10,30,Format(gX,fmta),Format(gY,fmta),Format(gZ,fmta)
     xystring 10,50,Format(rtod(atan2(gX,gZ))-90,fmtb)
     xystring -1,-1,Format(rtod(atan2(gY,gZ))-90,fmtb)
     xystring -1,-1,Format(rtod(atan2(gZ,gY)),fmtb)  
     call SendCommand(24,0,s)
     H = 0
     if SendCommand__Result then H = (getstrbyte(s,4)<<8)+getstrbyte(s,5)
     call PlotPlane(gX,gY,gZ,H)
  wend
End
//=================================
Initialization:
  fmta = "#0.0000   " \ fmtb = "  #00     "
  setcommport Port,br115200
  v = 0
  data plane;9,.5,6,1.5,4,1.5
  data plane;0,8.5,-1,8.5,-1,1.5,-4,.5,-5,3.5,-6,3.5
  data plane;-6,-3.5,-5,-3.5,-4,-0.5,-1,-1.5,-1,-8.5,0,-8.5
  data plane;4,-1.5,6,-1.5,9,-0.5,9,.5
  
  data Eye;170,pi(),pi(.30),1550,400,350 //rho,theta,phi,d,Cx,Cy
  dim Plane[maxdim(plane)/2,5]
  mconstant Plane,0
  for i=0 to maxdim(plane)/2 -1
    Plane[i,0] = plane[i*2]
    Plane[i,1] = plane[i*2+1]
  next
  flip on
  AddCheckBox "Mode",630,130,"&Real Mode",1,0
return
//=================================
sub SendCommand(C,P,&s)
  m = ""
 // serialout C,P
 // serbytesin 5,s,x
  call TCP_SendCommand(C,P,s,x)
  if x < 5 then m= "Comms Error"
  xystring 500,20,m,spaces(30)  
return (x == 5)
//=================================
sub PlotPlane(gX,gY,gZ,H)
  thX = atan2(gX,gZ)-pi(.5) //x-tilt
  thY = atan2(gY,gZ)-Pi(.5) //y-tilt
  mcopy Plane,K  //refresh body coordinates array
  geRotateA K,-thY,1 //rotate around x-axis i.e. Roll
                     //negative to orientate for Right-Handed Standard
  geRotateA K,thX,2  //rotate around y-axis i.e. Pitch
  //geRotateA K,dtor(-H),3  //rotate around z-axis i.e.Heading
                            //negative to orientate for Right-Handed Standard
  ge3dto2da K,Eye    //calculated screen coordinates
  for i=1 to maxdim(K)-1  //plot the plane
    line K[i-1,3],K[i-1,4],K[i,3],K[i,4]
  next
  call DisplayCompass(!GetCheckBox("Mode"),H,600,200) 
  call DisplayAttitude(thX,-thY,200,200)
  flip
  clearscr
return
//=================================
sub Read_H48C_E(&x,&y,&z,&xG,&yG,&zG)
  x = 0 \ y = 0 \ z = 0 
  xG =0 \ yG = 0 \ zG = 0
  m = ""
  //clearserbuffer \ serialout 71,0
  TCPC_Read() \ TCPC_Send(char(71)+char(0))
  //serbytesin 12,s,x
  GetTimeOut T \ T+=150 \ t = timer()
  repeat
     x = TCPC_BuffCount()
     if x ==12 then s = TCPC_Read() \ break
  until timer()-t > T
  if x < 12 then m= "Comms Error" \ return false
  xystring 500,20,m,spaces(30)  
  x = BuffReadI(s,0) 
  y = BuffReadI(s,4) 
  z = BuffReadI(s,8) 
  xG = x*.0022  //convert to g-forces
  yG = y*.0022
  zG = z*.0022
return true
//--------------------------------------------------

