//Complete_System_Tester.BAS
//works with Protocol_Main.Spin
Port = 16 //change this as per your system
#include "..\Utilities&IncludeFiles\Instruments.Bas"
//--------------------------------------------
Main:
  gosub Initialization
  GoSub SetAllLevels
  while true
    call CheckMouseKeyboard()
    call DoPing(_PX,_PY)
    call DoCompass()  
    call DoPots()
    call DoCheckBoxes(LastCheckBoxes)
    call DoAccelerometer(vRef)
    for i=23 to 21
      call SetBlinker("P"+i)
    next
  wend
end
//--------------------------------------------
Initialization:
  flip on
  fnt = "Times New Roman"
  data LEDState;white,red,yellow
  setcommport Port,br115200   //set serial comms
  xyText 390,100,"Last Command , Parameter",fnt,11,fs_Bold
  xyText 10,5,"P20..P18 LEDs",fnt,10,fs_Bold
  xyText 10,40,"P7..P5 Pushbuttons",fnt,10,fs_Bold
  xyText 640,110,"If Lit => error",fnt,10,fs_Bold
  for i=0 to 2
     AddCheckBox "DS"+i,25+20*i,20," "   //add checkboxes as bits to form the
  next                                    //number to send
  data sLabel;"Dimmer Level (P23)","P22 Blink Duration","P21 Blink Frequency"
  data sCommand; 200,201,2
  data sValue; 0,0,0,127,127,10
  for i=0 to 2
    xyString 240*i+30,175,sLabel[i]
    AddSlider "P"+(23-i),10+240*i,200,200,0,255  
    SetSliderPos "P"+(23-i),sValue[i+3]
    call MakeValue(i,sValue[i+3]) 
    xyText 80+240*i,245,MakeValue__Result,fnt,20,fs_Bold  
  next
  dim Pushbuttons[3], QTIs[3]
  call DrawDimmer(sValue[3])
  CheckBoxes = 0
  Command = 0 \ Parameter = 0   
  P22_Timer = timer() \ P22_State = 0  
  P21_Timer = timer() \ P21_State = 0  
  LastSlider()  'clear any slider events
  AddButton "&Reset The Propeller",640,10,155
  AddButton "&Save The Settings",640,35,155
  AddButton "Restore &Factory Settings",640,60,155
  xytext 50,100,"QTIs",fnt,10,fs_Bold
  AddCheckBox "Real &Mode",160,130,,1,0
  xytext 280,10,"gX",fnt,10,fs_Bold  
  xytext 380,10,"gZ",fnt,10,fs_Bold  
  xytext 440,10,"gZ",fnt,10,fs_Bold  
  xytext 525,10,"X",fnt,10,fs_Bold  
  xytext 590,10,"Y",fnt,10,fs_Bold  
  Spx = 500 \ Spy=520
  rectanglewh Spx,Spy,20,40
  line Spx+20,Spy,Spx+30,Spy-10
  lineto Spx+30,Spy+50
  Lineto Spx+19,Spy+39
  xystring Spx+5,Spy+5,"+"
  floodfill Spx+2,Spy+2,gray
  floodfill Spx+22,Spy,gray
  GoSub InitPing \ GoSub  InitPots \ GoSub InitMotors
  LastCheckBoxes = -1 
  dim LastBlinker[3] \ mconstant LastBlinker,-1
  vRef = 0 
  addtimer "t1",10
  onButton bHandler \ ontimer tHandler
Return
//--------------------------------------------
sub tHandler()
  lasttimer()
  if timer()-_P22_Timer > sValue[1]  //if P22 blinker time out
     _P22_State = !_P22_State \if !sValue[1] then _P22_State=0
     CircleWH 455,205,20,20,FactorColor(ConsToClr(yellow),-20),LEDState[_P22_State*2]
     _P22_Timer = timer() //reset timer
  endif
  if timer()-_P21_Timer > 500.0/Limit(sValue[2],1,255)  //if P22 blinker time out
     _P21_State = !_P21_State \if !sValue[2] then _P21_State=0
     CircleWH 695,205,20,20,FactorColor(ConsToClr(yellow),-20),LEDState[_P21_State*2]
     _P21_Timer = timer() //reset timer
  endif
  flip  
  ontimer tHandler
Return
//--------------------------------------------
SetAllLevels:
  call SendCommand(1,_CheckBoxes)    //force checkboxes to be reflected
  Call SendCommand(4,0,s)
  setsliderpos "P22",buffreadI(s,0)*255./16e7
  Call SendCommand(4,1,s)
  setsliderpos "P21",buffreadI(s,0)
  Call SendCommand(4,2,s)
  setsliderpos "P23",buffreadI(s,0)
Return
//--------------------------------------------
sub SendCommand(Command,Parameter,&s)
    if Command < 0 then s="" \ return false
    xyText 450,120, Format(Command,"##0"+spaces(10))+\
              ",  "+Format(Parameter,"  ##0        "),_fnt,10,fs_Bold
    ClearSerBuffer \ serialout Command,Parameter
    _Command = -1 \ _Parameter = -1
    serbytesin 5,s,x
    circlewh 600,100,30,30,red,LEDState[(x<5)]  //set the error LED
    if x < 5 then s = "" \ return false
    if Command == 66 || (Command == 70 && Parameter != 1) then return true
    Pushbuttons[0] = (getstrbyte(s,2)&0%10)>>1
    Pushbuttons[1] = getstrbyte(s,2)&0%01
    Pushbuttons[2] = getstrbyte(s,1)&0%1
    for i=0 to 2 
      circlewh 10+i*40,60,30,30,red,LEDState[Pushbuttons[i]]  //set the buttons' LEDs
      n=(Getstrbyte(s,3)&(1<<(2-i)))>>(2-i)
      circlewh 10+i*40,120,30,30,red,LEDState[n]  //set the QTI LEDs
    next
Return true
//--------------------------------------------
sub CheckMouseKeyboard()
  //while true
    P= 1\ C = -1 \ readmouse x,y,mb
    if mb=1
       call WhichIsIt(x,y,_MX,_MY,_MS,C)
       if within(x,_Spx,_Spx+30) && within(y,_Spy,_Spy+40) then C=73\P=67  //play note 70
    elseif KeyDown()
      if keydown(kc_UArrow) then C = 6
      if keydown(kc_DArrow) then C = 7  
      if keydown(kc_RArrow) then C = 12
      if keydown(kc_LArrow) then C = 13
      if keydown(kc_Space)  then C = 0   
    endif   
    if C == -1 then return
    if within(C,8,11) then P = 20
    call SendCommand(C,P)
  //wend 
return
//--------------------------------------------
sub bHandler()
  lb = LastButton()
  msg="Are you sure you want to reset the Propeller"+crlf()+\
               "If the program is in RAM you will lose it!"
  if left(lb,2) == "&R"
     if ErrMsg(msg,"RobotBASIC",MB_YESNO|MB_ERROR)==MB_YES
          call SendCommand(255,0)            //reset
          delay 2000
          GoSub SetAllLevels
     endif     
  elseif left(lb,2) == "&C"
     Hidebutton lb
     HideButton "&Finished",false
     mconstant P,0
     CopyScr ,350,400
     rectanglewh 380,405,300,80,black,black
     rectanglewh 378,402,300,80,black,gray
     xytext 384,410,"Move the Pots from max to min waiting a little while",\
             _fnt,10,fs_Bold,,gray
     xytext 384,430,"at each end then repeat the process a few times",_fnt,\
             10,fs_Bold,,gray  
    xytext 384,450,"When done press 'Finished'",_fnt,10,fs_Bold,,gray  
     _Calibrate = true
  elseif left(lb,2) == "&F"
     HideButton lb
     HideButton "&Calibrate",false
     _Calibrate = false
     copytoscr ,350,400
     call WriteLabels()
  elseif left(lb,2) == "&S"
     m = 0 \ mm = "Saving the parameters to the EEPROM "
     call SendCommand(5,0,s)
     if SendCommand__Result
       if getstrbyte(s,5) then m=1 
     endif
     if m = 1
       errmsg(mm+"Succeeded",ProgName(),MB_OK|MB_Information)
     else  
       errmsg(mm+"Failed",ProgName(),MB_OK|MB_Error)
     endif  
  elseif left(lb,2) == "Re"
     call SendCommand(5,1)
     m = "Factory settings restored in RAM only"
     errmsg(m,ProgName(),MB_OK|MB_Information)
     gosub SetAllLevels
  endif
  onbutton bHandler
return
//--------------------------------------------
sub DoCheckBoxes(&Last)
  P =0 
  for i=0 to 2
    P = MakeBit(P,2-i,GetCheckBox("DS"+i))    
  next
  if P != Last then call SendCommand(1,P) \ Last= P
Return
//--------------------------------------------
sub SetBlinker(ls)
    P = GetSliderPos(ls)
    n = 23-tonumber(substring(ls,2))
    if LastBlinker[n] == P then return
    C = sCommand[n]
    call SendCommand(C,P)
    if n == 0 then Call DrawDimmer(P)
    call MakeValue(n,P)
    xyText 80+240*n,245,MakeValue__Result,_fnt,20,fs_Bold
return
//--------------------------------------------
sub MakeValue(which,Level)
   n = Level
   if which == 0  'dimmer
      n = Level/256.0*3.3 
      Level = Format(n,"0.000 V  ")
   elseif which == 1  'P22 blink duration 
      n = Level*2000/256
      Level = Format(n,"####0 ms  ")
   else
      n = Level
      Level = Format(n,"##0  Hz  ")
   endif
   sValue[which] = n      
return Level
//--------------------------------------------
sub DrawDimmer(Level)
     CircleWH 212,202,26,26,white,white
     if !Level then return
     x = 1+(20*Level/256)/2
     Circle 225-x,215-x,225+x,215+x,red, RGB(Limit(Level,70,255),0,0)
return
//-----------------------------------------
InitPing:
  data units;"Millimeters","Meters","Inches","Feet","Yards"
  data unitn; " mm"," m"," in"," ft"," Yrds"
  data factors;1.,.001,Convert(.001,cc_MTOIN)
  data factors;Convert(.001,cc_MTOIN)/12
  data factors;Convert(Convert(.001,cc_MTOIN)/12,cc_FTTOYRD)
  AddRBGroup "Units",10,300,180,100,2,mToString(units)
  SetRBGroup "Units",1
  PX = 10 \ PY = 480 
  call DrawPing(PX,PY)
  savescr 0,400,350
Return
//-----------------------------------------
sub DoPing(Px,Py)
  C = 193
  if _TA < 0 then C = 192
  call SendCommand(C,Abs(_TA),s)
  if !SendCommand__Result then  return
  t = (getstrbyte(s,4)<<8)+getstrbyte(s,5) //reconstitute the value  
  call mmDistance(,t,D)                //convert to mm
  n=getrbgroup("Units")-1              //get desired units
  x=Format(D*factors[n],"0.0####")     //convert to units and format
  call DrawSignal(Px,Py,t,x+unitn[n])  //draw beam and display value in units
Return
//-----------------------------------------
sub DrawPing(x,y)   //draw picture of Ping device
  s = 30
  for i=-1 to 1 step 2
    line x,y+s*i,x+20,y+s*i,40,gray
    circlewh x+30,y-20+s*i,40,40,white,white
  next
  rectanglewh x-20,y-2*s,25,s*4,white,white
  rectanglewh x-2,y-s*2,10,s*4,green,green
Return
//-----------------------------------------
sub DrawSignal(x,y,d,str)
  d *= 200.0/19000      //scale value to screen coordinates
  restorescr 0,400
  xx1 = x+20+CartX(d,dtor(20))
  yy1 = y+CartY(d,dtor(20))
  Line x+20,y,xx1,yy1
  xx2 = x+20+CartX(d,dtor(-20))
  yy2 = y+CartY(d,dtor(-20))
  Line x+20,y,xx2,yy2
  Line xx1,yy1,xx2,yy2
  if d > 3 then floodfill x+20+d/2,y,black
  xytext x,y+80,str,,20,fs_bold
return
//-----------------------------------------
InitPots:
  dim P[2,3] \  mconstant P,0
  xytext 380,290,"Change the Pots' positions and observe the Sliders",fnt,9,fs_bold
  AddButton "&Calibrate",460,370
  AddButton "&Finished",460,370
  HideButton "&Finished"
  AddSlider "Pot0",220,310,250,0,6000
  AddSlider "Pot1",520,310,250,0,6000
  enableslider "Pot0",false \ enableslider "Pot1",false
  call WriteLabels()
  Calibrate = false
Return
//----------------------------------------
sub DoPots()
  call SendCommand(66,0,s)
  if !SendCommand__Result then return
  P2 = (getstrbyte(s,1)<<8)+getstrbyte(s,2)
  P1 = (getstrbyte(s,3)<<8)+getstrbyte(s,4)
  setsliderpos "Pot0",P1
  setsliderpos "Pot1",P2
  for i=0 to 1
     xystring 320+300*i,350,Format(GetSliderPos("Pot"+i),"####0")
  next
  If _Calibrate then Call Calibration(P1,P2)
Return
//----------------------------------------
sub WriteLabels()
  for i=0 to 1
     xystring 210+300*i,350,GetSliderMin("Pot"+i) 
     xystring 450+300*i,350,GetSliderMax("Pot"+i) 
     xystring 320+300*i,350,Format(GetSliderPos("Pot"+i),"####0")
  next   
return
//----------------------------------------
sub Calibration(P1,P2)
     P[0,1] = P1 \ P[1,1] = P2
     for i=0 to 1
        P[i,2] = MaxV(P[i,2],P[i,1]) 
        P[i,0] = MinV(P[i,0],P[i,1])         
        SetSliderMax "Pot"+i,P[i,2]
        SetSliderMin "Pot"+i,P[i,0]
        SetSliderPos "Pot"+i,P[i,1]
     next
     Call WriteLabels()
return
//-----------------------------------------
InitMotors:
  arrow = "UlulwwssldlU"
  MX = 750 \ MY = 500 \ MS = 10
  for i=0 to 3
     drawshape RotShape(arrow,i),MX,MY,MS
     floodfill ,,black
  next
  Turret = 0 \ TA =0 \  TX = 420 \ TY = 560
  for i=0 to 1
     drawshape RotShape(arrow,i*2),MX-20,MY-85,MS
     floodfill ,,black
     drawshape RotShape(arrow,i*2),MX+20,MY-85,MS
     floodfill ,,black
     drawshape RotShape(arrow,1+i*2),TX,TY,MS
     floodfill ,,black     
  next
  xyText 390,510,"Turret",fnt,15,fs_Bold
  xyText 600,550,"Move Motors with Keyboard Arrows",fnt,8,fs_Bold
  xyText 600,565,"Or Click on the arrows above",fnt,8,fs_Bold
  xyText 580,580,"Space or click in middle white box to Stop",fnt,8,fs_Bold  
  call SendCommand(241,90)
  call SendCommand(245,90)
Return
//-----------------------------------------
sub WhichIsIt(x,y,Cx,Cy,Scale,&n)
  n = -1 
  f2 = Scale*2 \ f4=Scale*4
  if within(x,Cx-f2,Cx+f2)       && within(y,Cy-f4,Cy-Scale)    then n=6
  if within(x,Cx-f2,Cx+f2)       && within(y,Cy+Scale,Cy+f4)    then n=7
  if within(x,Cx+Scale,Cx+f4)    && within(y,Cy-f2,Cy+f2)       then n=12
  if within(x,Cx-f4,Cx-Scale)    && within(y,Cy-f2,Cy+f2)       then n=13
  if within(x,Cx-Scale,Cx+Scale) && within(y,Cy-Scale,Cy+Scale) then n=0
  if within(x,Cx-f2-20,Cx+f2-20) && within(y,Cy-f4-85,Cy-Scale-85) then n= 10 
  if within(x,Cx-f2+20,Cx+f2+20) && within(y,Cy-f4-85,Cy-Scale-85) then n= 8  
  if within(x,Cx-f2-20,Cx+f2-20) && within(y,Cy+f4-85,Cy+Scale-85) then n= 11
  if within(x,Cx-f2+20,Cx+f2+20) && within(y,Cy+f4-85,Cy+Scale-85) then n= 9
  if within(x,_TX-f4,_TX-Scale)  && Within(y,_TY-f2,_TY+f2) then _TA = Limit(_TA-10,-90,90)
  if within(x,_TX+f4,_TX+Scale)  && Within(y,_TY-f2,_TY+f2) then _TA = Limit(_TA+10,-90,90)
return
//-----------------------------------------
sub DoCompass()
   call SendCommand(24,0,s)
   if !SendCommand__Result then return
   c = (getstrbyte(s,4)<<8)+getstrbyte(s,5)
   Allowevents off
   call DisplayCompass(!getcheckbox("Real &Mode"),c,210,100,,5)
   allowevents on
return
//-----------------------------------------
sub DoAccelerometer(&V)
  call Read_H48C(V,x,y,z,gX,gY,gZ)
  xystring 250,30,Format(gX,"0.0000', '")
  xystring -1,-1,Format(gY,"0.0000', '")
  xystring -1,-1,Format(gZ,"0.0000")
  thX = atan2(gX,gZ) \ thY = atan2(gY,gZ)
  xystring -1,-1,Format(rtod(thX)-90,"    ##0  ")
  xystring -1,-1,Format(rtod(thY)-90,"  ##0")
  //v = 0    //uncomment this to refresh the vRef all the time
  AllowEvents off
  call DisplayAttitude(thX-pi(.5),pi(.5)-thY,330,110,50,,3)
  AllowEvents on
return
//-----------------------------------------

